#!/usr/local/bin/perl

use lib ('/export/web/ipanalyze.example.com/data/lib');

use strict;
use DBI;
use Net::SMTP;
use IPAnalyze::Misc;
use IPAnalyze::IPmath;
use IPAnalyze::Customers;

my %cfg;
open(CONFIG, '/export/web/ipanalyze.example.com/data/ipanalyze.conf') || die "cannot open config: $!\n";
while(<CONFIG>){
   next if(/^[#;]/);
   chomp;
   if(/^(\S+)\s*=>\s?(.+)/){
      $cfg{$1} = $2;
   }
}
close CONFIG;

my $dbh = DBI->connect($cfg{d_dsn}, $cfg{d_dbun}, $cfg{d_dbpw}, {RaiseError => 1});
my $c_dbh;
if($cfg{c_dsn} && $cfg{c_dbun} && $cfg{c_dbpw}){
   unless(($cfg{d_dsn} eq $cfg{c_dsn}) && ($cfg{d_dbun} eq $cfg{c_dbun}) && ($cfg{d_dbpw} eq $cfg{c_dbpw})){
      $c_dbh = DBI->connect($cfg{c_dsn}, $cfg{c_dbun}, $cfg{c_dbpw}, {RaiseError => 1});
   }
}
my $misc = IPAnalyze::Misc->new();
my $ipmath = IPAnalyze::IPmath->new();
my $customers = IPAnalyze::Customers->new();
my $radius = DBI->connect('DBI:mysql:host=mysql.example.com;database=isp', 'root', undef, {RaiseError => 1});

my $lc = 'ISP Operations';
my $le = 'isp@example.com';
my $tn = 'Unknown';
my $te = 'bitbucket@example.com';
my $tp = '0';

open(F, "data");
while(<F>){
	chomp;
	my $netblock = $_;

	my $pid = $misc->get_pid($dbh,$ipmath,$netblock,30);

	my $sql = 'SELECT area FROM parent_networks WHERE id = ' . $dbh->quote($pid);
	my $sth = $dbh->prepare($sql);
	$sth->execute;
	my $row = $sth->fetchrow_arrayref;
	my $area = $row->[0];
	
	$sql = "SELECT username,btn,framed_route FROM radius_users WHERE framed_route LIKE \'${netblock}/%\'";
	$sth = $radius->prepare($sql);
	$sth->execute;
	$row = $sth->fetchrow_arrayref;
	my $username = $row->[0];
	my $btn = $row->[1];
	my ($rnet,$rcidr) = (split /\//, $row->[2])[0,1];

	if($username){
		my $cust = $customers->all($c_dbh,$dbh,'circuit_id',$username);
		my $uidcustid = $cust->[0];
		my $circuit_id = $username;
		unless($uidcustid){
			$cust = $customers->all($c_dbh,$dbh,'circuit_id',$btn);
		   $uidcustid = $cust->[0];
			$circuit_id = $btn;
			unless($uidcustid){
				warn "couldnt get OC8 info for $netblock\n";
				next;
			}
		}
	
		my $time = time();
		my $sql = 'INSERT INTO data (cust_id,circuit_id,area,parent_id,netblock,cidr,network_use,local_contact,local_email,';
		$sql .= 'tech_name,tech_email,tech_phone,status,bornondate) VALUES (';
		$sql .= $dbh->quote($cust->[0]) . ',' . $dbh->quote($circuit_id) . ',' . $dbh->quote($area) . ',';
		$sql .= $dbh->quote($pid) . ',';
		$sql .= $dbh->quote($netblock) . ',' . $dbh->quote($rcidr) . ',' . $dbh->quote('2') . ',';
		$sql .= $dbh->quote($lc) . ',' . $dbh->quote($le) . ',' . $dbh->quote($tn) . ',';
		$sql .= $dbh->quote($te) . ',' . $dbh->quote($tp);
		$sql .= ',0,'; # status
		$sql .= $dbh->quote($time) . ')';
	
		warn "sql: $sql\n";
		my $sth = $dbh->prepare($sql);
		$sth->execute;
	}else{
		warn "no radius data for $netblock\n";
	}
}
close F;
